// -------------------------------------------------------------------------------------
//
// Stanze.CS                                                      Ulrich Mller 02.06.02
//                                                                PCS1700       C# Final
// Stanzmaschine mit Transportband (51 663)
// mit FishFa30.DLL auf Basis von umFish30.DLL
//
// -------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using FishFa30;

namespace StanzeCS
{
	public class frmStanze : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Button cmdAction;
		private System.Windows.Forms.Button cmdEnde;
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.ComboBox cboPortName;
		private System.Windows.Forms.PictureBox pictureBox2;

		// --- FishFace : Klassen-Instanz -----------------------------------

		private FishFace ft = new FishFace();

		// --- Interface-Belegung -------------------------------------------
		
		const int mBand   = 1, cbVor   = 1, cbRuck  = 2,
				  ePhotoV = 1, ePhotoS = 2, mLampen = 3,
				  mStanze = 2, eOben   = 3, eUnten  = 4, csAb = 1, csAuf = 2,
				  ftiAus  = 0, ftiEin  = 1;

		private System.ComponentModel.Container components = null;

		// --- frmStanze : Konstruktor/Destruktor -------------------------------

		public frmStanze()
		{
			InitializeComponent();
			cboPortName.SelectedIndex = 1;
		}
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmStanze));
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.cmdAction = new System.Windows.Forms.Button();
			this.cmdEnde = new System.Windows.Forms.Button();
			this.lblStatus = new System.Windows.Forms.Label();
			this.cboPortName = new System.Windows.Forms.ComboBox();
			this.pictureBox2 = new System.Windows.Forms.PictureBox();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Bitmap)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(24, 24);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(443, 369);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// cmdAction
			// 
			this.cmdAction.Location = new System.Drawing.Point(504, 360);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(112, 32);
			this.cmdAction.TabIndex = 1;
			this.cmdAction.Text = "&START";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// cmdEnde
			// 
			this.cmdEnde.Location = new System.Drawing.Point(504, 320);
			this.cmdEnde.Name = "cmdEnde";
			this.cmdEnde.Size = new System.Drawing.Size(112, 32);
			this.cmdEnde.TabIndex = 2;
			this.cmdEnde.Text = "&ENDE";
			this.cmdEnde.Click += new System.EventHandler(this.cmdEnde_Click);
			// 
			// lblStatus
			// 
			this.lblStatus.Location = new System.Drawing.Point(480, 240);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(152, 24);
			this.lblStatus.TabIndex = 3;
			this.lblStatus.Text = "START/ENDE";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// cboPortName
			// 
			this.cboPortName.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboPortName.Items.AddRange(new object[] {
															 "LPT",
															 "COM1",
															 "COM2",
															 "COM3",
															 "COM4"});
			this.cboPortName.Location = new System.Drawing.Point(504, 288);
			this.cboPortName.Name = "cboPortName";
			this.cboPortName.Size = new System.Drawing.Size(112, 21);
			this.cboPortName.TabIndex = 4;
			// 
			// pictureBox2
			// 
			this.pictureBox2.Image = ((System.Drawing.Bitmap)(resources.GetObject("pictureBox2.Image")));
			this.pictureBox2.Location = new System.Drawing.Point(584, 32);
			this.pictureBox2.Name = "pictureBox2";
			this.pictureBox2.Size = new System.Drawing.Size(32, 32);
			this.pictureBox2.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.pictureBox2.TabIndex = 5;
			this.pictureBox2.TabStop = false;
			// 
			// frmStanze
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(648, 429);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.pictureBox2,
																		  this.cboPortName,
																		  this.lblStatus,
																		  this.cmdEnde,
																		  this.cmdAction,
																		  this.pictureBox1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "frmStanze";
			this.Text = "Stanzmaschine mit Transportband (51 663)";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmStanze_Closing);
			this.ResumeLayout(false);

		}
		#endregion

		// --- Der Haupteinstiegspunkt fr die Anwendung. ------------
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmStanze());
		}

		// --- Methode fr den Modellbetrieb, kann weitere Methoden aufrufen ---

		private void Action()
		{
			ft.ClearMotors();
			ft.SetMotor(mStanze, csAuf);
			ft.WaitForInput(eOben);
			ft.SetMotor(mStanze, ftiAus);
			ft.SetMotor(mLampen, ftiEin);
			do
			{
				lblStatus.Text = "Wartet";
				ft.WaitForLow(ePhotoV);
				ft.Pause(500);
				lblStatus.Text = "Zur Stanze";
				ft.SetMotor(mBand, cbVor);
				ft.WaitForLow(ePhotoS);
				ft.SetMotor(mBand, ftiAus);
				
				lblStatus.Text = "Stanzen";
				ft.SetMotor(mStanze, csAb);
				ft.WaitForInput(eUnten);
				ft.SetMotor(mStanze, ftiAus);
				ft.Pause(1000);
				ft.SetMotor(mStanze, csAuf);
				ft.WaitForInput(eOben);
				ft.SetMotor(mStanze, ftiAus);

				lblStatus.Text = "Zurck";
				ft.SetMotor(mBand, cbRuck);
				ft.WaitForInput(ePhotoV, false);
				ft.Pause(300);
				ft.SetMotor(mBand, ftiAus);
			} while (!ft.Finish());
		}

		// --- Schlieen der Form ablehen, wenn das Modell noch luft
		
		private void frmStanze_Closing(object sender, 
			System.ComponentModel.CancelEventArgs e)
		{
			if(cmdEnde.Text == "&HALT") e.Cancel = true;
		}

		// --- Beenden des Modellbetriebs bei Button = HALT, Beenden des Programms
		//     bei Button = ENDE

		private void cmdEnde_Click(object sender, System.EventArgs e)
		{
			if(cmdEnde.Text == "&HALT") ft.NotHalt = true; this.Close();
		}

		// --- Steuern des Modellbetriebs ----------------------------------------
		
		private void cmdAction_Click(object sender, System.EventArgs e)
		{
			try
			{
				ft.OpenInterface(cboPortName.SelectedIndex);
				cmdAction.Enabled = false;
				cmdEnde.Text      = "&HALT";
				lblStatus.Text    = "luft";
				cmdEnde.Focus();

				Action();

				ft.ClearMotors();
				lblStatus.Text    = "START/ENDE";
				ft.CloseInterface();
			}
			catch(FishFaceException eft)
			{
				lblStatus.Text = eft.Message;
				ft.NotHalt = true;
			}
			finally
			{
				cmdAction.Enabled = true;
				cmdEnde.Text      = "&ENDE";
			}
		}
	}
}
