// ---------------------------------------------------------------------------------------
// 
// ManRefSCons.CS                                                   Ulrich Mller 04.06.04
//                                                                  PCS17000      C# Final
// Testrahmen fr die Beispiele zu Fish30.FishStep
//
// ---------------------------------------------------------------------------------------

using System;
using cn = System.Console;
using FishFa30;

namespace ManRefRCons
{
	class ManRef
	{
		static FishStep ft = new FishStep(new int[,]{{1,456},{3,456}});

		[STAThread]
		static void Main(string[] args)
		{
			ft.StepChange += new FishStep.StepDelegate(StepPosition);
			ft.PlotChange += new FishStep.PlotDelegate(PlotPosition);

			try 
			{
				ft.OpenInterface(Port.COM2);  // --- ggf. anpassen
				cn.WriteLine("--- ManRef gestartet ---");
				// --- Hier Code einfgen ----
			}
			catch(FishFaceException eft)
			{
				cn.WriteLine(eft.Message);
			}
			finally 
			{
				ft.CloseInterface();
				cn.WriteLine("---Finito---");
				cn.Read();
			}
		}
		static void StepPosition(object sender, int MotNr, int actPos)
		{
			cn.WriteLine("Aktuelle Step-Position : " + actPos.ToString());
		}
		static void PlotPosition(object sender, int MotNr, int xPos, int yPos)
		{
			cn.WriteLine("Akt Plot-Position : " + xPos.ToString() +
				" / " + yPos.ToString());
		}
	}
}
