// ----------------------------------------------------------------------------------------
//
// ManRefCons.CS                                                     Ulrich Mller 26.05.04
//                                                                   PCS1700       C# Final
// Testrahmen fr die Beispiele von "ftComputing : FishFa30 fr C#", Kapitel Referenz
//
// ----------------------------------------------------------------------------------------

using System;
using cn = System.Console;
using FishFa30;

namespace ManRefCons
{
	class ManRef
	{
		static FishFace ft = new FishFace(true, false, 0);

		[STAThread]
		static void Main(string[] args)
		{
			try 
			{
				ft.OpenInterface(Port.COM2);
				cn.WriteLine("--- InputStatus ---");
				string EWerte = "";
				for(int i = 0x80, E = ft.Inputs; i > 0; i >>= 1) 
					EWerte += (E & i) > 0 ? "1" : "0";
				cn.WriteLine("InputStatus binr : " + EWerte.ToString());
				cn.WriteLine("InputStatus Hexa  : " + ft.Inputs.ToString("X"));
				cn.WriteLine("EX : " + ft.GetAnalog(Nr.EX).ToString());
			}
			catch(FishFaceException eft) 
			{
				cn.WriteLine(eft.Message);
			}
			finally 
			{
				ft.CloseInterface();
				cn.WriteLine("--- Finito ---");
				cn.Read();
			}
		}
	}
}
