// --------------------------------------------------------------------------------------
//
// frmMain(FiPanl30.CS)                                            Ulrich Mller 28.05.02
//                                                                 PCS1700       C# Final
// FishPanel Standalone auf Basis FishFa30.DLL                     
//
// --------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using FishFa30;

namespace FiPanl30
{
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Panel pnlButtons;
		private System.Windows.Forms.Button cmdAction;
		private System.Windows.Forms.Button cmdEnde;
		private System.Windows.Forms.CheckBox chkSlave;
		private System.Windows.Forms.ComboBox cboPorts;
		private System.Timers.Timer tmrI;
		private System.Windows.Forms.Panel pnlIn2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Label label24;
		private System.Windows.Forms.Label label35;
		private System.Windows.Forms.Label label50;
		private System.Windows.Forms.Label label52;
		private System.Windows.Forms.Label label53;
		private System.Windows.Forms.Label lblEingabe13;
		private System.Windows.Forms.Label lblEingabe14;
		private System.Windows.Forms.Label lblEingabe15;
		private System.Windows.Forms.Label lblEingabe16;
		private System.Windows.Forms.Label lblEingabe09;
		private System.Windows.Forms.Label lblEingabe10;
		private System.Windows.Forms.Label lblEingabe11;
		private System.Windows.Forms.Label lblEingabe12;
		private System.Windows.Forms.Panel pnlIn1;
		private System.Windows.Forms.Label lblEingabe03;
		private System.Windows.Forms.Label lblEingabe04;
		private System.Windows.Forms.Label lblEingabe05;
		private System.Windows.Forms.Label lblEingabe06;
		private System.Windows.Forms.Label lblEingabe07;
		private System.Windows.Forms.Label lblEingabe08;
		private System.Windows.Forms.Panel pnlMot2;
		private System.Windows.Forms.Label lblMotor8;
		private System.Windows.Forms.Label lblDreh09;
		private System.Windows.Forms.Label lblDreh10;
		private System.Windows.Forms.Label lblDreh11;
		private System.Windows.Forms.Label lblDreh12;
		private System.Windows.Forms.Label lblDreh13;
		private System.Windows.Forms.Label lblDreh14;
		private System.Windows.Forms.Label lblDreh15;
		private System.Windows.Forms.Label lblDreh16;
		private System.Windows.Forms.Label lblmotor7;
		private System.Windows.Forms.Label lblMotor6;
		private System.Windows.Forms.Label lblMotor5;
		private System.Windows.Forms.Panel pnlMot1;
		private System.Windows.Forms.Label lblmotor1;
		private System.Windows.Forms.Label lblMotor2;
		private System.Windows.Forms.Label lblMotor3;
		private System.Windows.Forms.Label lblMotor4;
		private System.Windows.Forms.Label lblDreh01;
		private System.Windows.Forms.Label lblDreh02;
		private System.Windows.Forms.Label lblDreh03;
		private System.Windows.Forms.Label lblDreh04;
		private System.Windows.Forms.Label lblDreh05;
		private System.Windows.Forms.Label lblDreh06;
		private System.Windows.Forms.Label lblDreh07;
		private System.Windows.Forms.Label lblDreh08;
		private System.Windows.Forms.Label lblEHex;
		private System.Windows.Forms.Label lblAHex;
		private System.Windows.Forms.Label lblReady;
		private System.ComponentModel.Container components = null;

		// ---- private, global Deklarationen ------------------------------

		FishFace ft;
		Label[] AusgabeLabel = new Label[17];
		private System.Windows.Forms.Label lblEingabe01;
		private System.Windows.Forms.Label lblEingabe02;
		private System.Windows.Forms.Panel pnlAnalog;
		private System.Windows.Forms.Label lblAnalogY;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label lblAnalogX;
		private System.Windows.Forms.Label label1;
		private Label[] EingabeLabel = new Label[17];
		private bool[] MotorDauer = new bool[9];
		private int[] EMaske = {0, 0x1,    0x2,    0x4,    0x8, 
								   0x10,   0x20,   0x40,   0x80, 
								   0x100,  0x200,  0x400,  0x800, 
								   0x1000, 0x2000, 0x4000, 0x8000};

		// --- Konstruktor ----------------------------------------------------

		public frmMain()
		{
			InitializeComponent();
			cboPorts.SelectedIndex = 1;
			AusgabeLabel[1]  = lblDreh01;
			AusgabeLabel[2]  = lblDreh02;
			AusgabeLabel[3]  = lblDreh03;
			AusgabeLabel[4]  = lblDreh04;
			AusgabeLabel[5]  = lblDreh05;
			AusgabeLabel[6]  = lblDreh06;
			AusgabeLabel[7]  = lblDreh07;
			AusgabeLabel[8]  = lblDreh08;
			AusgabeLabel[9]  = lblDreh09;
			AusgabeLabel[10] = lblDreh10;
			AusgabeLabel[11] = lblDreh11;
			AusgabeLabel[12] = lblDreh12;
			AusgabeLabel[13] = lblDreh13;
			AusgabeLabel[14] = lblDreh14;
			AusgabeLabel[15] = lblDreh15;
			AusgabeLabel[16] = lblDreh16;
			EingabeLabel[1]  = lblEingabe01;
			EingabeLabel[2]  = lblEingabe02;
			EingabeLabel[3]  = lblEingabe03;
			EingabeLabel[4]  = lblEingabe04;
			EingabeLabel[5]  = lblEingabe05;
			EingabeLabel[6]  = lblEingabe06;
			EingabeLabel[7]  = lblEingabe07;
			EingabeLabel[8]  = lblEingabe08;
			EingabeLabel[9]  = lblEingabe09;
			EingabeLabel[10] = lblEingabe10;
			EingabeLabel[11] = lblEingabe11;
			EingabeLabel[12] = lblEingabe12;
			EingabeLabel[13] = lblEingabe13;
			EingabeLabel[14] = lblEingabe14;
			EingabeLabel[15] = lblEingabe15;
			EingabeLabel[16] = lblEingabe16;
		}
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMain));
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.pnlButtons = new System.Windows.Forms.Panel();
			this.lblReady = new System.Windows.Forms.Label();
			this.cboPorts = new System.Windows.Forms.ComboBox();
			this.chkSlave = new System.Windows.Forms.CheckBox();
			this.cmdEnde = new System.Windows.Forms.Button();
			this.cmdAction = new System.Windows.Forms.Button();
			this.tmrI = new System.Timers.Timer();
			this.pnlIn2 = new System.Windows.Forms.Panel();
			this.label13 = new System.Windows.Forms.Label();
			this.label12 = new System.Windows.Forms.Label();
			this.lblEingabe09 = new System.Windows.Forms.Label();
			this.lblEingabe10 = new System.Windows.Forms.Label();
			this.lblEingabe11 = new System.Windows.Forms.Label();
			this.lblEingabe12 = new System.Windows.Forms.Label();
			this.lblEingabe13 = new System.Windows.Forms.Label();
			this.lblEingabe14 = new System.Windows.Forms.Label();
			this.lblEingabe15 = new System.Windows.Forms.Label();
			this.lblEingabe16 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.pnlIn1 = new System.Windows.Forms.Panel();
			this.label14 = new System.Windows.Forms.Label();
			this.label15 = new System.Windows.Forms.Label();
			this.lblEingabe01 = new System.Windows.Forms.Label();
			this.lblEingabe02 = new System.Windows.Forms.Label();
			this.lblEingabe03 = new System.Windows.Forms.Label();
			this.lblEingabe04 = new System.Windows.Forms.Label();
			this.lblEingabe05 = new System.Windows.Forms.Label();
			this.lblEingabe06 = new System.Windows.Forms.Label();
			this.lblEingabe07 = new System.Windows.Forms.Label();
			this.lblEingabe08 = new System.Windows.Forms.Label();
			this.label24 = new System.Windows.Forms.Label();
			this.pnlMot2 = new System.Windows.Forms.Panel();
			this.lblMotor5 = new System.Windows.Forms.Label();
			this.lblMotor6 = new System.Windows.Forms.Label();
			this.lblmotor7 = new System.Windows.Forms.Label();
			this.lblMotor8 = new System.Windows.Forms.Label();
			this.lblDreh09 = new System.Windows.Forms.Label();
			this.lblDreh10 = new System.Windows.Forms.Label();
			this.lblDreh11 = new System.Windows.Forms.Label();
			this.lblDreh12 = new System.Windows.Forms.Label();
			this.lblDreh13 = new System.Windows.Forms.Label();
			this.lblDreh14 = new System.Windows.Forms.Label();
			this.lblDreh15 = new System.Windows.Forms.Label();
			this.lblDreh16 = new System.Windows.Forms.Label();
			this.label35 = new System.Windows.Forms.Label();
			this.pnlMot1 = new System.Windows.Forms.Panel();
			this.lblmotor1 = new System.Windows.Forms.Label();
			this.lblMotor2 = new System.Windows.Forms.Label();
			this.lblMotor3 = new System.Windows.Forms.Label();
			this.lblMotor4 = new System.Windows.Forms.Label();
			this.lblDreh01 = new System.Windows.Forms.Label();
			this.lblDreh02 = new System.Windows.Forms.Label();
			this.lblDreh03 = new System.Windows.Forms.Label();
			this.lblDreh04 = new System.Windows.Forms.Label();
			this.lblDreh05 = new System.Windows.Forms.Label();
			this.lblDreh06 = new System.Windows.Forms.Label();
			this.lblDreh07 = new System.Windows.Forms.Label();
			this.lblDreh08 = new System.Windows.Forms.Label();
			this.label50 = new System.Windows.Forms.Label();
			this.lblEHex = new System.Windows.Forms.Label();
			this.label52 = new System.Windows.Forms.Label();
			this.label53 = new System.Windows.Forms.Label();
			this.lblAHex = new System.Windows.Forms.Label();
			this.pnlAnalog = new System.Windows.Forms.Panel();
			this.lblAnalogY = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.lblAnalogX = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.pnlButtons.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.tmrI)).BeginInit();
			this.pnlIn2.SuspendLayout();
			this.pnlIn1.SuspendLayout();
			this.pnlMot2.SuspendLayout();
			this.pnlMot1.SuspendLayout();
			this.pnlAnalog.SuspendLayout();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Location = new System.Drawing.Point(32, 304);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(32, 32);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// pnlButtons
			// 
			this.pnlButtons.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.lblReady,
																					 this.cboPorts,
																					 this.chkSlave,
																					 this.cmdEnde,
																					 this.cmdAction});
			this.pnlButtons.Location = new System.Drawing.Point(200, 264);
			this.pnlButtons.Name = "pnlButtons";
			this.pnlButtons.Size = new System.Drawing.Size(272, 88);
			this.pnlButtons.TabIndex = 1;
			// 
			// lblReady
			// 
			this.lblReady.BackColor = System.Drawing.Color.DimGray;
			this.lblReady.Location = new System.Drawing.Point(112, 16);
			this.lblReady.Name = "lblReady";
			this.lblReady.Size = new System.Drawing.Size(16, 16);
			this.lblReady.TabIndex = 4;
			// 
			// cboPorts
			// 
			this.cboPorts.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboPorts.Items.AddRange(new object[] {
														  "LPT",
														  "COM1",
														  "COM2",
														  "COM3",
														  "COM4",
														  "COM5",
														  "COM6",
														  "COM7",
														  "COM8"});
			this.cboPorts.Location = new System.Drawing.Point(152, 16);
			this.cboPorts.Name = "cboPorts";
			this.cboPorts.Size = new System.Drawing.Size(96, 24);
			this.cboPorts.TabIndex = 3;
			// 
			// chkSlave
			// 
			this.chkSlave.Checked = true;
			this.chkSlave.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkSlave.Location = new System.Drawing.Point(24, 16);
			this.chkSlave.Name = "chkSlave";
			this.chkSlave.Size = new System.Drawing.Size(80, 16);
			this.chkSlave.TabIndex = 2;
			this.chkSlave.Text = "Mit Slave";
			this.chkSlave.Click += new System.EventHandler(this.chkSlave_Click);
			// 
			// cmdEnde
			// 
			this.cmdEnde.Location = new System.Drawing.Point(24, 48);
			this.cmdEnde.Name = "cmdEnde";
			this.cmdEnde.Size = new System.Drawing.Size(104, 24);
			this.cmdEnde.TabIndex = 1;
			this.cmdEnde.Text = "&Abbrechen";
			this.cmdEnde.Click += new System.EventHandler(this.cmdEnde_Click);
			// 
			// cmdAction
			// 
			this.cmdAction.Location = new System.Drawing.Point(144, 48);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(104, 24);
			this.cmdAction.TabIndex = 0;
			this.cmdAction.Text = "&START";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// tmrI
			// 
			this.tmrI.Interval = 200;
			this.tmrI.SynchronizingObject = this;
			this.tmrI.Elapsed += new System.Timers.ElapsedEventHandler(this.tmrI_Elapsed);
			// 
			// pnlIn2
			// 
			this.pnlIn2.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.label13,
																				 this.label12,
																				 this.lblEingabe09,
																				 this.lblEingabe10,
																				 this.lblEingabe11,
																				 this.lblEingabe12,
																				 this.lblEingabe13,
																				 this.lblEingabe14,
																				 this.lblEingabe15,
																				 this.lblEingabe16,
																				 this.label3});
			this.pnlIn2.Enabled = false;
			this.pnlIn2.Location = new System.Drawing.Point(104, 24);
			this.pnlIn2.Name = "pnlIn2";
			this.pnlIn2.Size = new System.Drawing.Size(184, 72);
			this.pnlIn2.TabIndex = 6;
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(152, 48);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(24, 14);
			this.label13.TabIndex = 10;
			this.label13.Text = "E9";
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(8, 48);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(32, 14);
			this.label12.TabIndex = 9;
			this.label12.Text = "E16";
			// 
			// lblEingabe09
			// 
			this.lblEingabe09.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe09.Location = new System.Drawing.Point(158, 16);
			this.lblEingabe09.Name = "lblEingabe09";
			this.lblEingabe09.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe09.TabIndex = 8;
			this.lblEingabe09.Text = "E";
			// 
			// lblEingabe10
			// 
			this.lblEingabe10.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe10.Location = new System.Drawing.Point(140, 16);
			this.lblEingabe10.Name = "lblEingabe10";
			this.lblEingabe10.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe10.TabIndex = 7;
			this.lblEingabe10.Text = "E";
			// 
			// lblEingabe11
			// 
			this.lblEingabe11.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe11.Location = new System.Drawing.Point(122, 16);
			this.lblEingabe11.Name = "lblEingabe11";
			this.lblEingabe11.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe11.TabIndex = 6;
			this.lblEingabe11.Text = "E";
			// 
			// lblEingabe12
			// 
			this.lblEingabe12.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe12.Location = new System.Drawing.Point(104, 16);
			this.lblEingabe12.Name = "lblEingabe12";
			this.lblEingabe12.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe12.TabIndex = 5;
			this.lblEingabe12.Text = "E";
			// 
			// lblEingabe13
			// 
			this.lblEingabe13.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe13.Location = new System.Drawing.Point(70, 16);
			this.lblEingabe13.Name = "lblEingabe13";
			this.lblEingabe13.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe13.TabIndex = 4;
			this.lblEingabe13.Text = "E";
			// 
			// lblEingabe14
			// 
			this.lblEingabe14.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe14.Location = new System.Drawing.Point(52, 16);
			this.lblEingabe14.Name = "lblEingabe14";
			this.lblEingabe14.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe14.TabIndex = 3;
			this.lblEingabe14.Text = "E";
			// 
			// lblEingabe15
			// 
			this.lblEingabe15.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe15.Location = new System.Drawing.Point(34, 16);
			this.lblEingabe15.Name = "lblEingabe15";
			this.lblEingabe15.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe15.TabIndex = 2;
			this.lblEingabe15.Text = "E";
			// 
			// lblEingabe16
			// 
			this.lblEingabe16.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe16.Location = new System.Drawing.Point(16, 16);
			this.lblEingabe16.Name = "lblEingabe16";
			this.lblEingabe16.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe16.TabIndex = 1;
			this.lblEingabe16.Text = "E";
			// 
			// label3
			// 
			this.label3.BackColor = System.Drawing.Color.LightGray;
			this.label3.Location = new System.Drawing.Point(8, 8);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(168, 32);
			this.label3.TabIndex = 0;
			// 
			// pnlIn1
			// 
			this.pnlIn1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.label14,
																				 this.label15,
																				 this.lblEingabe01,
																				 this.lblEingabe02,
																				 this.lblEingabe03,
																				 this.lblEingabe04,
																				 this.lblEingabe05,
																				 this.lblEingabe06,
																				 this.lblEingabe07,
																				 this.lblEingabe08,
																				 this.label24});
			this.pnlIn1.Enabled = false;
			this.pnlIn1.Location = new System.Drawing.Point(304, 24);
			this.pnlIn1.Name = "pnlIn1";
			this.pnlIn1.Size = new System.Drawing.Size(184, 72);
			this.pnlIn1.TabIndex = 7;
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(152, 48);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(24, 14);
			this.label14.TabIndex = 10;
			this.label14.Text = "E1";
			// 
			// label15
			// 
			this.label15.Location = new System.Drawing.Point(8, 48);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(32, 14);
			this.label15.TabIndex = 9;
			this.label15.Text = "E8";
			// 
			// lblEingabe01
			// 
			this.lblEingabe01.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe01.Location = new System.Drawing.Point(158, 16);
			this.lblEingabe01.Name = "lblEingabe01";
			this.lblEingabe01.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe01.TabIndex = 8;
			this.lblEingabe01.Text = "E";
			// 
			// lblEingabe02
			// 
			this.lblEingabe02.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe02.Location = new System.Drawing.Point(140, 16);
			this.lblEingabe02.Name = "lblEingabe02";
			this.lblEingabe02.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe02.TabIndex = 7;
			this.lblEingabe02.Text = "E";
			// 
			// lblEingabe03
			// 
			this.lblEingabe03.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe03.Location = new System.Drawing.Point(122, 16);
			this.lblEingabe03.Name = "lblEingabe03";
			this.lblEingabe03.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe03.TabIndex = 6;
			this.lblEingabe03.Text = "E";
			// 
			// lblEingabe04
			// 
			this.lblEingabe04.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe04.Location = new System.Drawing.Point(104, 16);
			this.lblEingabe04.Name = "lblEingabe04";
			this.lblEingabe04.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe04.TabIndex = 5;
			this.lblEingabe04.Text = "E";
			// 
			// lblEingabe05
			// 
			this.lblEingabe05.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe05.Location = new System.Drawing.Point(70, 16);
			this.lblEingabe05.Name = "lblEingabe05";
			this.lblEingabe05.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe05.TabIndex = 4;
			this.lblEingabe05.Text = "E";
			// 
			// lblEingabe06
			// 
			this.lblEingabe06.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe06.Location = new System.Drawing.Point(52, 16);
			this.lblEingabe06.Name = "lblEingabe06";
			this.lblEingabe06.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe06.TabIndex = 3;
			this.lblEingabe06.Text = "E";
			// 
			// lblEingabe07
			// 
			this.lblEingabe07.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe07.Location = new System.Drawing.Point(34, 16);
			this.lblEingabe07.Name = "lblEingabe07";
			this.lblEingabe07.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe07.TabIndex = 2;
			this.lblEingabe07.Text = "E";
			// 
			// lblEingabe08
			// 
			this.lblEingabe08.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEingabe08.Location = new System.Drawing.Point(16, 16);
			this.lblEingabe08.Name = "lblEingabe08";
			this.lblEingabe08.Size = new System.Drawing.Size(14, 20);
			this.lblEingabe08.TabIndex = 1;
			this.lblEingabe08.Text = "E";
			// 
			// label24
			// 
			this.label24.BackColor = System.Drawing.Color.LightGray;
			this.label24.Location = new System.Drawing.Point(8, 8);
			this.label24.Name = "label24";
			this.label24.Size = new System.Drawing.Size(168, 32);
			this.label24.TabIndex = 0;
			// 
			// pnlMot2
			// 
			this.pnlMot2.Controls.AddRange(new System.Windows.Forms.Control[] {
																				  this.lblMotor5,
																				  this.lblMotor6,
																				  this.lblmotor7,
																				  this.lblMotor8,
																				  this.lblDreh09,
																				  this.lblDreh10,
																				  this.lblDreh11,
																				  this.lblDreh12,
																				  this.lblDreh13,
																				  this.lblDreh14,
																				  this.lblDreh15,
																				  this.lblDreh16,
																				  this.label35});
			this.pnlMot2.Enabled = false;
			this.pnlMot2.Location = new System.Drawing.Point(104, 112);
			this.pnlMot2.Name = "pnlMot2";
			this.pnlMot2.Size = new System.Drawing.Size(184, 72);
			this.pnlMot2.TabIndex = 8;
			// 
			// lblMotor5
			// 
			this.lblMotor5.AutoSize = true;
			this.lblMotor5.BackColor = System.Drawing.Color.LightGray;
			this.lblMotor5.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblMotor5.Location = new System.Drawing.Point(144, 48);
			this.lblMotor5.Name = "lblMotor5";
			this.lblMotor5.Size = new System.Drawing.Size(26, 19);
			this.lblMotor5.TabIndex = 12;
			this.lblMotor5.Tag = "5";
			this.lblMotor5.Text = "M5";
			this.lblMotor5.Click += new System.EventHandler(this.lblMotorClick);
			// 
			// lblMotor6
			// 
			this.lblMotor6.AutoSize = true;
			this.lblMotor6.BackColor = System.Drawing.Color.LightGray;
			this.lblMotor6.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblMotor6.Location = new System.Drawing.Point(112, 48);
			this.lblMotor6.Name = "lblMotor6";
			this.lblMotor6.Size = new System.Drawing.Size(26, 19);
			this.lblMotor6.TabIndex = 11;
			this.lblMotor6.Tag = "6";
			this.lblMotor6.Text = "M6";
			this.lblMotor6.Click += new System.EventHandler(this.lblMotorClick);
			// 
			// lblmotor7
			// 
			this.lblmotor7.AutoSize = true;
			this.lblmotor7.BackColor = System.Drawing.Color.LightGray;
			this.lblmotor7.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblmotor7.Location = new System.Drawing.Point(56, 48);
			this.lblmotor7.Name = "lblmotor7";
			this.lblmotor7.Size = new System.Drawing.Size(26, 19);
			this.lblmotor7.TabIndex = 10;
			this.lblmotor7.Tag = "7";
			this.lblmotor7.Text = "M7";
			this.lblmotor7.Click += new System.EventHandler(this.lblMotorClick);
			// 
			// lblMotor8
			// 
			this.lblMotor8.AutoSize = true;
			this.lblMotor8.BackColor = System.Drawing.Color.LightGray;
			this.lblMotor8.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblMotor8.Location = new System.Drawing.Point(20, 48);
			this.lblMotor8.Name = "lblMotor8";
			this.lblMotor8.Size = new System.Drawing.Size(26, 19);
			this.lblMotor8.TabIndex = 9;
			this.lblMotor8.Tag = "8";
			this.lblMotor8.Text = "M8";
			this.lblMotor8.Click += new System.EventHandler(this.lblMotorClick);
			// 
			// lblDreh09
			// 
			this.lblDreh09.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh09.Location = new System.Drawing.Point(158, 16);
			this.lblDreh09.Name = "lblDreh09";
			this.lblDreh09.Size = new System.Drawing.Size(14, 20);
			this.lblDreh09.TabIndex = 8;
			this.lblDreh09.Tag = "9";
			this.lblDreh09.Text = "L";
			this.lblDreh09.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehUp);
			this.lblDreh09.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// lblDreh10
			// 
			this.lblDreh10.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh10.Location = new System.Drawing.Point(140, 16);
			this.lblDreh10.Name = "lblDreh10";
			this.lblDreh10.Size = new System.Drawing.Size(14, 20);
			this.lblDreh10.TabIndex = 7;
			this.lblDreh10.Tag = "10";
			this.lblDreh10.Text = "R";
			this.lblDreh10.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehUp);
			this.lblDreh10.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// lblDreh11
			// 
			this.lblDreh11.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh11.Location = new System.Drawing.Point(122, 16);
			this.lblDreh11.Name = "lblDreh11";
			this.lblDreh11.Size = new System.Drawing.Size(14, 20);
			this.lblDreh11.TabIndex = 6;
			this.lblDreh11.Tag = "11";
			this.lblDreh11.Text = "L";
			this.lblDreh11.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehUp);
			this.lblDreh11.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// lblDreh12
			// 
			this.lblDreh12.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh12.Location = new System.Drawing.Point(104, 16);
			this.lblDreh12.Name = "lblDreh12";
			this.lblDreh12.Size = new System.Drawing.Size(14, 20);
			this.lblDreh12.TabIndex = 5;
			this.lblDreh12.Tag = "12";
			this.lblDreh12.Text = "R";
			this.lblDreh12.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehUp);
			this.lblDreh12.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// lblDreh13
			// 
			this.lblDreh13.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh13.Location = new System.Drawing.Point(70, 16);
			this.lblDreh13.Name = "lblDreh13";
			this.lblDreh13.Size = new System.Drawing.Size(14, 20);
			this.lblDreh13.TabIndex = 4;
			this.lblDreh13.Tag = "13";
			this.lblDreh13.Text = "L";
			this.lblDreh13.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehUp);
			this.lblDreh13.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// lblDreh14
			// 
			this.lblDreh14.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh14.Location = new System.Drawing.Point(52, 16);
			this.lblDreh14.Name = "lblDreh14";
			this.lblDreh14.Size = new System.Drawing.Size(14, 20);
			this.lblDreh14.TabIndex = 3;
			this.lblDreh14.Tag = "14";
			this.lblDreh14.Text = "R";
			this.lblDreh14.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehUp);
			this.lblDreh14.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// lblDreh15
			// 
			this.lblDreh15.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh15.Location = new System.Drawing.Point(34, 16);
			this.lblDreh15.Name = "lblDreh15";
			this.lblDreh15.Size = new System.Drawing.Size(14, 20);
			this.lblDreh15.TabIndex = 2;
			this.lblDreh15.Tag = "15";
			this.lblDreh15.Text = "L";
			this.lblDreh15.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehUp);
			this.lblDreh15.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// lblDreh16
			// 
			this.lblDreh16.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh16.Location = new System.Drawing.Point(16, 16);
			this.lblDreh16.Name = "lblDreh16";
			this.lblDreh16.Size = new System.Drawing.Size(14, 20);
			this.lblDreh16.TabIndex = 1;
			this.lblDreh16.Tag = "16";
			this.lblDreh16.Text = "R";
			this.lblDreh16.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehUp);
			this.lblDreh16.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// label35
			// 
			this.label35.BackColor = System.Drawing.Color.LightGray;
			this.label35.Location = new System.Drawing.Point(8, 8);
			this.label35.Name = "label35";
			this.label35.Size = new System.Drawing.Size(168, 32);
			this.label35.TabIndex = 0;
			// 
			// pnlMot1
			// 
			this.pnlMot1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				  this.lblmotor1,
																				  this.lblMotor2,
																				  this.lblMotor3,
																				  this.lblMotor4,
																				  this.lblDreh01,
																				  this.lblDreh02,
																				  this.lblDreh03,
																				  this.lblDreh04,
																				  this.lblDreh05,
																				  this.lblDreh06,
																				  this.lblDreh07,
																				  this.lblDreh08,
																				  this.label50});
			this.pnlMot1.Enabled = false;
			this.pnlMot1.Location = new System.Drawing.Point(304, 112);
			this.pnlMot1.Name = "pnlMot1";
			this.pnlMot1.Size = new System.Drawing.Size(184, 72);
			this.pnlMot1.TabIndex = 9;
			// 
			// lblmotor1
			// 
			this.lblmotor1.AutoSize = true;
			this.lblmotor1.BackColor = System.Drawing.Color.LightGray;
			this.lblmotor1.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblmotor1.Location = new System.Drawing.Point(144, 48);
			this.lblmotor1.Name = "lblmotor1";
			this.lblmotor1.Size = new System.Drawing.Size(26, 19);
			this.lblmotor1.TabIndex = 12;
			this.lblmotor1.Tag = "1";
			this.lblmotor1.Text = "M1";
			this.lblmotor1.Click += new System.EventHandler(this.lblMotorClick);
			// 
			// lblMotor2
			// 
			this.lblMotor2.AutoSize = true;
			this.lblMotor2.BackColor = System.Drawing.Color.LightGray;
			this.lblMotor2.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblMotor2.Location = new System.Drawing.Point(112, 48);
			this.lblMotor2.Name = "lblMotor2";
			this.lblMotor2.Size = new System.Drawing.Size(26, 19);
			this.lblMotor2.TabIndex = 11;
			this.lblMotor2.Tag = "2";
			this.lblMotor2.Text = "M2";
			this.lblMotor2.Click += new System.EventHandler(this.lblMotorClick);
			// 
			// lblMotor3
			// 
			this.lblMotor3.AutoSize = true;
			this.lblMotor3.BackColor = System.Drawing.Color.LightGray;
			this.lblMotor3.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblMotor3.Location = new System.Drawing.Point(56, 48);
			this.lblMotor3.Name = "lblMotor3";
			this.lblMotor3.Size = new System.Drawing.Size(26, 19);
			this.lblMotor3.TabIndex = 10;
			this.lblMotor3.Tag = "3";
			this.lblMotor3.Text = "M3";
			this.lblMotor3.Click += new System.EventHandler(this.lblMotorClick);
			// 
			// lblMotor4
			// 
			this.lblMotor4.AutoSize = true;
			this.lblMotor4.BackColor = System.Drawing.Color.LightGray;
			this.lblMotor4.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblMotor4.Location = new System.Drawing.Point(16, 48);
			this.lblMotor4.Name = "lblMotor4";
			this.lblMotor4.Size = new System.Drawing.Size(26, 19);
			this.lblMotor4.TabIndex = 9;
			this.lblMotor4.Tag = "4";
			this.lblMotor4.Text = "M4";
			this.lblMotor4.Click += new System.EventHandler(this.lblMotorClick);
			// 
			// lblDreh01
			// 
			this.lblDreh01.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh01.Location = new System.Drawing.Point(158, 16);
			this.lblDreh01.Name = "lblDreh01";
			this.lblDreh01.Size = new System.Drawing.Size(14, 20);
			this.lblDreh01.TabIndex = 8;
			this.lblDreh01.Tag = "1";
			this.lblDreh01.Text = "L";
			this.lblDreh01.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehUp);
			this.lblDreh01.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// lblDreh02
			// 
			this.lblDreh02.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh02.Location = new System.Drawing.Point(140, 16);
			this.lblDreh02.Name = "lblDreh02";
			this.lblDreh02.Size = new System.Drawing.Size(14, 20);
			this.lblDreh02.TabIndex = 7;
			this.lblDreh02.Tag = "2";
			this.lblDreh02.Text = "R";
			this.lblDreh02.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehUp);
			this.lblDreh02.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// lblDreh03
			// 
			this.lblDreh03.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh03.Location = new System.Drawing.Point(122, 16);
			this.lblDreh03.Name = "lblDreh03";
			this.lblDreh03.Size = new System.Drawing.Size(14, 20);
			this.lblDreh03.TabIndex = 6;
			this.lblDreh03.Tag = "3";
			this.lblDreh03.Text = "L";
			this.lblDreh03.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehUp);
			this.lblDreh03.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// lblDreh04
			// 
			this.lblDreh04.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh04.Location = new System.Drawing.Point(104, 16);
			this.lblDreh04.Name = "lblDreh04";
			this.lblDreh04.Size = new System.Drawing.Size(14, 20);
			this.lblDreh04.TabIndex = 5;
			this.lblDreh04.Tag = "4";
			this.lblDreh04.Text = "R";
			this.lblDreh04.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehUp);
			this.lblDreh04.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// lblDreh05
			// 
			this.lblDreh05.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh05.Location = new System.Drawing.Point(70, 16);
			this.lblDreh05.Name = "lblDreh05";
			this.lblDreh05.Size = new System.Drawing.Size(14, 20);
			this.lblDreh05.TabIndex = 4;
			this.lblDreh05.Tag = "5";
			this.lblDreh05.Text = "L";
			this.lblDreh05.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehUp);
			this.lblDreh05.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// lblDreh06
			// 
			this.lblDreh06.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh06.Location = new System.Drawing.Point(52, 16);
			this.lblDreh06.Name = "lblDreh06";
			this.lblDreh06.Size = new System.Drawing.Size(14, 20);
			this.lblDreh06.TabIndex = 3;
			this.lblDreh06.Tag = "6";
			this.lblDreh06.Text = "R";
			this.lblDreh06.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			this.lblDreh06.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// lblDreh07
			// 
			this.lblDreh07.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh07.Location = new System.Drawing.Point(34, 16);
			this.lblDreh07.Name = "lblDreh07";
			this.lblDreh07.Size = new System.Drawing.Size(14, 20);
			this.lblDreh07.TabIndex = 2;
			this.lblDreh07.Tag = "7";
			this.lblDreh07.Text = "L";
			this.lblDreh07.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehUp);
			this.lblDreh07.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// lblDreh08
			// 
			this.lblDreh08.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDreh08.Location = new System.Drawing.Point(16, 16);
			this.lblDreh08.Name = "lblDreh08";
			this.lblDreh08.Size = new System.Drawing.Size(14, 20);
			this.lblDreh08.TabIndex = 1;
			this.lblDreh08.Tag = "8";
			this.lblDreh08.Text = "R";
			this.lblDreh08.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lblDrehUp);
			this.lblDreh08.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lblDrehDown);
			// 
			// label50
			// 
			this.label50.BackColor = System.Drawing.Color.LightGray;
			this.label50.Location = new System.Drawing.Point(8, 8);
			this.label50.Name = "label50";
			this.label50.Size = new System.Drawing.Size(168, 32);
			this.label50.TabIndex = 0;
			// 
			// lblEHex
			// 
			this.lblEHex.BackColor = System.Drawing.Color.LightGray;
			this.lblEHex.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblEHex.Location = new System.Drawing.Point(32, 40);
			this.lblEHex.Name = "lblEHex";
			this.lblEHex.Size = new System.Drawing.Size(56, 24);
			this.lblEHex.TabIndex = 10;
			this.lblEHex.Text = "0000";
			this.lblEHex.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label52
			// 
			this.label52.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label52.Location = new System.Drawing.Point(32, 72);
			this.label52.Name = "label52";
			this.label52.Size = new System.Drawing.Size(56, 16);
			this.label52.TabIndex = 11;
			this.label52.Text = "Input";
			this.label52.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label53
			// 
			this.label53.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label53.Location = new System.Drawing.Point(32, 160);
			this.label53.Name = "label53";
			this.label53.Size = new System.Drawing.Size(56, 16);
			this.label53.TabIndex = 13;
			this.label53.Text = "Output";
			this.label53.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblAHex
			// 
			this.lblAHex.BackColor = System.Drawing.Color.LightGray;
			this.lblAHex.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblAHex.Location = new System.Drawing.Point(32, 120);
			this.lblAHex.Name = "lblAHex";
			this.lblAHex.Size = new System.Drawing.Size(56, 24);
			this.lblAHex.TabIndex = 12;
			this.lblAHex.Text = "0000";
			this.lblAHex.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// pnlAnalog
			// 
			this.pnlAnalog.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.lblAnalogY,
																					this.label2,
																					this.lblAnalogX,
																					this.label1});
			this.pnlAnalog.Location = new System.Drawing.Point(200, 200);
			this.pnlAnalog.Name = "pnlAnalog";
			this.pnlAnalog.Size = new System.Drawing.Size(272, 48);
			this.pnlAnalog.TabIndex = 14;
			// 
			// lblAnalogY
			// 
			this.lblAnalogY.BackColor = System.Drawing.Color.LightGray;
			this.lblAnalogY.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblAnalogY.Location = new System.Drawing.Point(208, 16);
			this.lblAnalogY.Name = "lblAnalogY";
			this.lblAnalogY.Size = new System.Drawing.Size(56, 16);
			this.lblAnalogY.TabIndex = 9;
			this.lblAnalogY.Text = "0000";
			this.lblAnalogY.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(168, 12);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(32, 16);
			this.label2.TabIndex = 8;
			this.label2.Text = "EY";
			// 
			// lblAnalogX
			// 
			this.lblAnalogX.BackColor = System.Drawing.Color.LightGray;
			this.lblAnalogX.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblAnalogX.Location = new System.Drawing.Point(104, 16);
			this.lblAnalogX.Name = "lblAnalogX";
			this.lblAnalogX.Size = new System.Drawing.Size(48, 16);
			this.lblAnalogX.TabIndex = 7;
			this.lblAnalogX.Text = "0000";
			this.lblAnalogX.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(4, 12);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(80, 24);
			this.label1.TabIndex = 6;
			this.label1.Text = "Analog EX";
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 16);
			this.ClientSize = new System.Drawing.Size(504, 373);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.pnlAnalog,
																		  this.label53,
																		  this.lblAHex,
																		  this.label52,
																		  this.lblEHex,
																		  this.pnlMot1,
																		  this.pnlMot2,
																		  this.pnlIn1,
																		  this.pnlIn2,
																		  this.pnlButtons,
																		  this.pictureBox1});
			this.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "frmMain";
			this.Text = "FishFa21 : FishPanel";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmMain_Closing);
			this.pnlButtons.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.tmrI)).EndInit();
			this.pnlIn2.ResumeLayout(false);
			this.pnlIn1.ResumeLayout(false);
			this.pnlMot2.ResumeLayout(false);
			this.pnlMot1.ResumeLayout(false);
			this.pnlAnalog.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}


		// --- MotorAusS : Ausschalten eines Motorausganges ------------------------

		private void MotorAusS(int Mnr)
		{
			ft.SetMotor(Mnr, Convert.ToInt32(Dir.Off));
			AusgabeLabel[Mnr*2-1].BackColor = Color.Gray;
			AusgabeLabel[Mnr*2].BackColor   = Color.Gray;
			lblAHex.Text = String.Format("{0:X4}", ft.Outputs);
		}

		// --- PanelAktivieren : Anzeigen, Button-Steuerung ----------------------

		private void PanelAktivieren()
		{
			pnlMot1.Enabled = true;
			if(chkSlave.Checked) pnlMot2.Enabled = true; else pnlMot2.Enabled = false;
			chkSlave.Enabled   = false;
			tmrI.Enabled       = true;
			cmdAction.Text     = "&ENDE";
			cmdEnde.Text       = "&RESET";
			lblReady.BackColor = Color.Green;
		}

		// --- cmdAction_Click : Starten Interface -------------------------------

		private void cmdAction_Click(object sender, System.EventArgs e)
		{
			if(cmdAction.Text == "&START")
			{
				try
				{
					ft = new FishFace(true, chkSlave.Checked ? true : false, 0);
					ft.OpenInterface(cboPorts.SelectedIndex);
					PanelAktivieren();
				}
				catch(FishFaceException eft)
				{
					MessageBox.Show("InterfaceProblem : " + eft.Message, "FishPanel",
						MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				}
			}
			else
			{
				this.Close();
			}
		}

		// --- chkSlave_Click : Auswahl mit/ohne Slave, Modifikation der Anzeige -----

		private void chkSlave_Click(object sender, System.EventArgs e)
		{
			if(chkSlave.Checked)
			{
				pnlIn2.Visible   = true;
				pnlMot2.Visible  = true;
				pnlAnalog.Left   = 192;
				pnlIn1.Left      = 304;
				pnlMot1.Left     = 304;
				pnlAnalog.Left   = 200;
				pnlButtons.Left  = 200;
				this.Width       = 512;
			}
			else
			{
				pnlIn2.Visible  = false;
				pnlMot2.Visible = false;
				pnlAnalog.Left  = lblAHex.Location.X;
				pnlIn1.Left     = pnlAnalog.Location.X + pnlAnalog.Size.Width
					              - pnlIn1.Size.Width;
				pnlMot1.Left    = pnlAnalog.Location.X + pnlAnalog.Size.Width 
					              - pnlIn1.Size.Width;
				pnlButtons.Left = pnlAnalog.Location.X + 20;
				this.Width      = 333;
			}
		}

		// --- cmdEnde_Click : Abbruch / RESET --------------------------------

		private void cmdEnde_Click(object sender, System.EventArgs e)
		{
			if(cmdEnde.Text == "&RESET") ft.ClearMotors(); else this.Close();
		}

		// --- Zyklische Anzeige dies Interface-Status --------------------------

		private void tmrI_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
		{
			int InputStatus;
			try
			{
				InputStatus = ft.GetInputs();
				lblReady.BackColor = Color.Green;
				lblAnalogX.Text = ft.GetAnalog(Nr.EX).ToString();
				lblAnalogY.Text = ft.GetAnalog(Nr.EY).ToString();
				int OG = chkSlave.Checked ? 16 : 8;
				for(int i=1; i<=OG; i++)
				{
					if(ft.GetInput(i)) EingabeLabel[i].BackColor = Color.LightGreen; 
					else EingabeLabel[i].BackColor = Color.Gray;
					if((ft.Outputs & EMaske[i]) != 0) 
						AusgabeLabel[i].BackColor = Color.LightGreen;
					else AusgabeLabel[i].BackColor = Color.Gray;
					lblAHex.Text = String.Format("{0:X4}", ft.Outputs);
					lblEHex.Text = String.Format("{0:X4}", ft.GetInputs());
				}
			}
			catch(FishFaceException)
			{
				lblReady.BackColor = Color.Red;
				cmdEnde.Enabled = false;
			}
		}

		// --- frmMain_Closing : Schlieen Interface -------------------------------

		private void frmMain_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			tmrI.Enabled = false;
		}

		// --- lblDrehDown : MouseDown bei R/L-Labels --------------------------------

		private void lblDrehDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			int Ri;
			Keys keyMode = Control.ModifierKeys;
			Label l = (Label)sender;
			int Index = Convert.ToInt32(l.Tag);
			if((Index % 2) == 0) Ri = 2; else Ri = 1;
			int Mnr = (Index-1) / 2 + 1;
			if(keyMode == Keys.Control | keyMode == Keys.Shift) MotorDauer[Mnr] = true;
			ft.SetMotor(Mnr, Ri);
			l.BackColor = Color.LightGreen;
			lblAHex.Text = String.Format("{0:X4}", ft.Outputs);
		}

		// --- lblDrehUp : MouseUp bei R/L-Labels ------------------------------------

		private void lblDrehUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Label l = (Label)sender;
			int Index = Convert.ToInt32(l.Tag);
			int Mnr = (Index-1) /2 +1;
			if(MotorDauer[Mnr]) return; else MotorAusS(Mnr);
		}

		// --- lblMotorClick : Beenden M-Ausgang ------------------------------------

		private void lblMotorClick(object sender, System.EventArgs e)
		{
			Label l = (Label)sender;
			int Index = Convert.ToInt32(l.Tag);
			MotorDauer[Index] = false;
			MotorAusS(Index);
		}
	}
}
